<template>
    <div class = "container">
        <h1 className = "text-center mt-5">To-Do List</h1>

        <div class="d-flex justify-content-center">
            <input v-model="task" v-on:keyup.enter="addTask" type="text" placeholder="Enter task" class="form-control w-50 p-3">
            <button @click="addTask" type="button" class="btn btn-outline-success">Submit</button>
        </div>

        <table class="table table-stripped">
            <thead>
                <th> Task Id </th>
                <th> Task Description </th>
                <th> Task Status </th>
                <th> Actions </th>
            </thead>
            <tbody>
                <tr v-for = "todo in todos" v-bind:key = "todo.id">
                    <td> {{ todo.id }} </td>
                    <td> {{ todo.description }} </td>
                    <td> 
                        <input @click="completeTask(todo.id)" v-model="todo.done" class="form-check-input" type="checkbox" value="" id="flexCheckChecked">
                    </td>
                    <td>
                        <button @click="editTask(todo.id)" type="button" class="btn btn-warning">Edit</button>
                        <button @click="deleteTask(todo.id)" type="button" class="btn btn-danger">Remove</button>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>
</template>

<script>
import TodoService from "../services/TodoService.js"

    const findTaskById = (todos, id) => {
        return todos.find(todo => todo.id == id);
    };

    export default {
        name: "ToDos",
        data() {
            return {
                task : "",
                todos : [],
                editedTask : null
            }
        },
        methods: {
            getTodos() {
                TodoService.getTodos().then((response) => {
                    this.todos = response.data;
                }).catch(err => console.log(err));
            },
            addTask() {
                if (this.task.length === 0) return;
                if (this.editedTask === null) {
                    TodoService.addTodo(this.task).then(response => this.todos.push(response.data)).catch(err => console.log(err));
                } else {
                    let tempTask = findTaskById(this.todos, this.editedTask);
                    TodoService.editTodoDescription(this.editedTask, this.task).then(res => tempTask.description = res.data.description).catch(err => console.log(err));
                    this.editedTask = null
                }
                this.task = '';
            },
            editTask(id) {
                let tempTask = findTaskById(this.todos, id);
                this.task = tempTask.description;
                this.editedTask = id;
            },
            deleteTask(id) {
                TodoService.deleteTodo(id);
                this.todos = this.todos.filter(todo => !(todo.id == id));
            },
            completeTask(id) {
                let tempTask = findTaskById(this.todos, id);
                TodoService.editTodoDone(id, !tempTask.done).then(res => tempTask.done = res.data.done).catch(err => console.log(err));
            }
        },
        created() {
            this.getTodos()
        }
    }
</script>

<style>
</style>
